# BaseFileLock class

(Shortest import: `from brian2.utils.filelock import BaseFileLock)`

class brian2.utils.filelock.BaseFileLock(lock_file, timeout=-1)

  Bases: `object`

  Implements the base class of a file lock.

  Attributes

  `is_locked` | True, if the object holds the file lock.
  `lock_file` | The path to the lock file.
  `timeout` | You can set a default timeout for the filelock.

  Methods

  `acquire`([timeout, poll_intervall]) | Acquires the file lock or fails with a `Timeout` error.
  `release`([force]) | Releases the file lock.

  Details

  is_locked

    True, if the object holds the file lock.

    Changed in version 2.0.0: This was previously a method and is now a property.

  lock_file

    The path to the lock file.

  timeout

    You can set a default timeout for the filelock. It will be used as fallback value in the acquire method, if no timeout value (None) is given.

    If you want to disable the timeout, set it to a negative value.

    A timeout of 0 means, that there is exactly one attempt to acquire the file lock.

    Added in version 2.0.0.

  acquire(timeout=None, poll_intervall=0.05)

    Acquires the file lock or fails with a `Timeout` error.

        # You can use this method in the context manager (recommended)
        with lock.acquire():
            pass

        # Or use an equivalent try-finally construct:
        lock.acquire()
        try:
            pass
        finally:
            lock.release()

    Parameters:

      - timeout (float) – The maximum time waited for the file lock. If `timeout < 0`, there is no timeout and this method will block until the lock could be acquired. If `timeout` is None, the default `timeout` is used.

      - poll_intervall (float) – We check once in poll_intervall seconds if we can acquire the file lock.

    Raises:

      Timeout – if the lock could not be acquired in timeout seconds.

    Changed in version 2.0.0: This method returns now a proxy object instead of self, so that it can be used in a with statement without side effects.

  release(force=False)

    Releases the file lock.

    Please note, that the lock is only completly released, if the lock counter is 0.

    Also note, that the lock file itself is not automatically deleted.

    Parameters:

      force (bool) – If true, the lock counter is ignored and the lock is released in every case.